/*** 
 * \file gre/3dfmtex.h
 * \brief FORMULA TEXTURE texturing algorithms
 *
 * \if NODOC
 * $Id: 3dfmtex.h_v 1.9 2011/10/20 12:34:31 mju Exp $
 *
 * $Log: 3dfmtex.h_v $
 * Revision 1.9  2011/10/20 12:34:31  mju
 * Remove redundant hdr.
 *
 * Revision 1.8  2011/10/06 14:27:48  mju
 * Use trans2dmapgen hdr.
 *
 * Revision 1.7  2006/10/18 15:25:44  mju
 * Use colorcompstruct* instead of colorcomphandle typedef.
 *
 * Revision 1.1  2004/06/17 17:26:06  vdronov
 * Initial revision
 * \endif
**/ 

#ifndef	INC_GRE_3DFMTEX_H
#define	INC_GRE_3DFMTEX_H

#ifndef	INC_GRE_3DTEXTUR_H
#include <gre/3dtextur.h>
#endif

#ifndef	INC_MI32_TRANS2D_MAPGEN_H
#include <mi32/trans2dmapgen.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
struct COLORCOMPSTRUCT;
#endif

namespace GRE {

class FORMULATEXTURE : public TEXTURE {
	public:

		FORMULATEXTURE (			 							  
			);

		virtual ~FORMULATEXTURE (								//! Destructor
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT

		const GRE::LAYER_FORMULA *m_Layer;
		DRECT2D ALIGN16(m_Extents);
		SPATREF::COORDREFSYS m_CoordRefSys;
		TRANS2D_MAPGEN m_Transformation;

		COLORCOMPSTRUCT *m_CCHandle;

		bool m_IsNullTransparent;

		FORMULATEXTURE (											//! Copy constructor (not implemented)
			const FORMULATEXTURE& rhs
			);

		FORMULATEXTURE& operator= (								//! Assignment operator (not implemented)
			const FORMULATEXTURE& rhs
			);

		TEXTURE* v_CreateInstance (
			) { return new FORMULATEXTURE(); };

		ERRVALUE v_Build (
			const GRE::LAYER *layer
			);

		void v_Free (
			);

		void v_Begin (
			const SCENE3D& scene
			);

		void v_End (
			);

		const DRECT2D& v_GetExtents (
			) { return m_Extents; };

		void v_CreateBoundary (
			REGION2D& boundary
			);

		void v_SetCoordRefSys (
			const SPATREF::COORDREFSYS& CoordRefSys
			);

		const SPATREF::COORDREFSYS v_GetCoordRefSys (
			) { return m_CoordRefSys; };

		bool GetColor (
			const DPOINT2D& point,
			COLOR& color 
			);

		bool v_GetColor (
			const INT32 line,
			const INT32 column,
			const UINT8 depth,
			COLOR& color 
			);

		bool v_GetColor (
			const DPOINT2D& point,
			const UINT8 depth,
			COLOR& color 
			);

		UINT8 v_CheckDepth (
			const UINT8 depth
			);

		const TRANS2D_MAPGEN& v_GetTransformationInternalToModel (
			) { return m_Transformation; };

		#endif // GENERATING_DOXYGEN_OUTPUT

	};

}		// End of GRE namespace

#endif



