/**
 * \file mgui/formrawdata.h
 * \brief MGUI::FORM_RAWDATA definitions
 *
 * \if NODOC
 * $Id: formrawdata.h_v 1.1 2011/06/01 20:55:10 mju Exp $
 *
 * $Log: formrawdata.h_v $
 * Revision 1.1  2011/06/01 20:55:10  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MGUI_FORMRAWDATA_H
#define	INC_MGUI_FORMRAWDATA_H

#ifndef	INC_MGUI_FORM_H
#include <mgui/form.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
class GENERICRW;
#endif

namespace MGUI {

class FORM_RAWDATA : FORM_COMPOSITE {
	public:

		enum STYLE {
			STYLE_Default =		0x00,
//			STYLE_AllowEdit =		0x01,
			};

		//! Default constructor.
		FORM_RAWDATA ();

		//! Destructor.
		virtual ~FORM_RAWDATA ();

		//! Attach reader/writer.
		void AttachRW (
			GENERICRW *pRW,				//! Reader/Writer for accessing raw data
			bool TakeOwnership			//! True to take ownership (and subsequently destroy) specified RW instance
			);

		//! Create the form.
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane,
			int heightRows = 8,
			int widthPixels = 200,
			STYLE style = STYLE_Default,
			MGUI::LAYOUT_SIZEALIGN sizealign = MGUI::LAYOUT_SIZEALIGN_Expand
			);

		//! Update.
		void Update ();

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		#endif
	};

#ifndef GENERATING_DOXYGEN_OUTPUT
DEFINE_ENUM_OP_BITWISE(FORM_RAWDATA::STYLE)
#endif

}

#endif	// INC_MGUI_FORMRAWDATA_H
