/**
 * \file mi32/inspmem.h
 * \brief INSPMEM class definition.
 *
 * \if NODOC
 * $Id: inspmem.h_v 1.10 2012/01/11 21:39:49 mju Exp $
 *
 * $Log: inspmem.h_v $
 * Revision 1.10  2012/01/11 21:39:49  mju
 * Remove unused prototype.
 *
 * Revision 1.9  2011/11/28 17:27:09  mju
 * Remove unneeded check for x_native.
 *
 * Revision 1.1  2003/01/06 18:40:38  msmith
 * Initial revision
 * \endif
**/

#ifndef	INC_MI32_INSPMEM_H
#define	INC_MI32_INSPMEM_H

#ifndef	INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>
#endif

class INSPPRIVDATA;

class INSPMEM {
	public:

		INSPMEM ();

		~INSPMEM ();

		//! Creates the controls inside the form provided:
		//! attribute selections and the drawing area for
		//! displaying text
		ERRVALUE Create (
			Widget form
			);

		//! Sets the buffer to display
		ERRVALUE SetBuffer (
			const void *buffer,
			int size
			);

		//! Update allows for proper resizing of the arrow buttons.
		//! Must be called after XtRealizeWidget or XtManageChild is called
		void Update (
			);

	private:
	   #ifndef GENERATING_DOXYGEN_OUTPUT
		INSPPRIVDATA *m_pPriv;
		#endif // GENERATING_DOXYGEN_OUTPUT
	};

#endif	// INC_MI32_INSPMEM_H
