/**
 * \file mi32/xbase.h
 * \brief Base X declarations
 *
 * \if NODOC
 * $Id: xbase.h_v 1.5 2010/03/05 16:23:39 mju Exp $
 *
 * $Log: xbase.h_v $
 * Revision 1.5  2010/03/05 16:23:39  mju
 * Define xid and pixmap.
 *
 * Revision 1.4  2006/10/06 17:04:43  mju
 * Fwd declare boolean.
 *
 * Revision 1.3  2006/09/21 15:16:33  mju
 * Fwd declare menuitem and button item stuff.
 *
 * Revision 1.2  2006/09/20 17:54:28  mju
 * Add xtintervalid.
 *
 * Revision 1.1  2006/09/20 17:07:45  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_XBASE_H
#define	INC_MI32_XBASE_H

#ifndef GENERATING_DOXYGEN_OUTPUT
union _XEvent;
typedef _XEvent XEvent;
class XTARGS;
typedef unsigned long XID;
typedef unsigned long XtIntervalId;
typedef XID Pixmap;
struct BUTTONITEM;
class BUTTONITEMARRAY;
struct MENUITEM;
class MENUITEMARRAY;
struct MENUBARITEM;
#ifdef WIN64
typedef long Boolean;
#else
typedef char Boolean;
#endif
#endif

#endif	// INC_MI32_XBASE_H

