/******************************************************************************
 *
 * \file sml/histo.h
 * \brief SML HISTOGRAM
 *
 * \if NODOC
 * $Log: histo.h_v $
 * Revision 1.3  2011/10/12 14:35:33  mju
 * Remove redundant hdr.
 *
 * Revision 1.2  2007/05/08 15:46:04  dwilliss
 * SML namespace
 *
 * Revision 1.1  2007/05/07 14:13:46  dwilliss
 * Initial revision
 *
 * \endif
*/
/*****************************************************************************/

#ifndef INC_SML_HISTO_H
#define INC_SML_HISTO_H

#ifndef INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>
#endif

#ifdef RVCSYSDLL
	#define RVCSYSLIBEXPORT MI_DLLEXPORT
	#define RVCSYSLIBCLASSEXPORT MI_DLLCLASSEXPORT
#else
	#define RVCSYSLIBEXPORT MI_DLLIMPORT
	#define RVCSYSLIBCLASSEXPORT MI_DLLCLASSIMPORT
#endif

namespace SML {

#ifndef GENERATING_DOXYGEN_OUTPUT
struct HISTOBUCKET {
	double val;
	INT32 count;
	HISTOBUCKET *next;
	};

class RVCSYSLIBCLASSEXPORT HISTO {
	public:
		INT32 Count[256];
		HISTOBUCKET *Others;

		HISTO();
		~HISTO();
		void AddValue(double);
		double GetMajority() const;
		double GetMinority() const;
		double GetMedian() const;
		double GetCount() const;
	};
#endif // GENERATING_DOXYGEN_OUTPUT

} // end of SML namepsace

typedef SML::HISTO SMLHISTO;
typedef SML::HISTOBUCKET SMLHISTOBUCKET;

#undef RVCSYSLIBEXPORT
#undef RVCSYSLIBCLASSEXPORT

#endif		//  INC_SML_HISTO_H


