/**
 * \file usage.h <sml/smlusage.h>
 * \brief Base SML declarations
 *
 * \if NODOC
 * $Id: usage.h_v 1.3 2007/05/17 21:22:25 dwilliss Exp $
 *
 * $Log: usage.h_v $
 * Revision 1.3  2007/05/17 21:22:25  dwilliss
 * added USAGE_LAST
 *
 * Revision 1.2  2007/05/08 15:46:35  dwilliss
 * SML namespace
 *
 * Revision 1.1  2007/05/07 15:04:06  dwilliss
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_SML_USAGE_H
#define	INC_SML_USAGE_H

namespace SML {

enum USAGE {
	USAGE_Undefined = 0,
	USAGE_StandAlone,
	USAGE_ToolScript,
	USAGE_MacroScript,
	USAGE_DisplayControlScript,
	USAGE_Select,
	USAGE_GeoFormula,
	USAGE_StyleScript,			//!< Style By Script
	USAGE_ComputedField,			//!< Database computed field (numeric)
	USAGE_StringExpression,		//!< Database string expression field
	USAGE_Callback,				//!< A script fragment used as a callback
	USAGE_ScriptLayer,			//!< A GRE SML script layer
	USAGE_NumericExpression,	//!< Script returning an arbitrary number
	USAGE_LAST						//!< Highest defined usage value
	};

} // end of SML namespace

typedef enum SML::USAGE SMLUSAGE;


// legacy names -- these should eventually be deprecated
#define SMLUSAGE_Undefined SML::USAGE_Undefined
#define SMLUSAGE_StandAlone SML::USAGE_StandAlone
#define SMLUSAGE_ToolScript SML::USAGE_ToolScript
#define SMLUSAGE_MacroScript SML::USAGE_MacroScript
#define SMLUSAGE_DisplayControlScript SML::USAGE_DisplayControlScript
#define SMLUSAGE_Select SML::USAGE_Select
#define SMLUSAGE_GeoFormula SML::USAGE_GeoFormula
#define SMLUSAGE_StyleScript SML::USAGE_StyleScript
#define SMLUSAGE_ComputedField SML::USAGE_ComputedField
#define SMLUSAGE_StringExpression SML::USAGE_StringExpression
#define SMLUSAGE_Callback SML::USAGE_Callback
#define SMLUSAGE_ScriptLayer SML::USAGE_ScriptLayer
#define SMLUSAGE_NumericExpression SML::USAGE_NumericExpression

#endif	// INC_SML_USAGE_H
