/**
 * \file databuffer.h <spatmod/databuffer.h>
 * \brief Spatial Modelling (SPATMOD) DATABUFFER class definition
 *
 * \if NODOC
 * $Id: databuffer.h_v 1.3 2008/08/28 13:51:12 mju Exp $
 *
 * $Log: databuffer.h_v $
 * Revision 1.3  2008/08/28 13:51:12  mju
 * Add missing doxygen endif.
 *
 * Revision 1.2  2006/07/27 22:03:17  mju
 * Add spaces for nested template so builds on unix.
 *
 * Revision 1.1  2006/07/27 19:29:42  mju
 * Initial revision
 * \endif
**/

#ifndef	INC_SPATMOD_DATABUFFER_H
#define	INC_SPATMOD_DATABUFFER_H

#ifndef	INC_MI32_DOUBLEAR_H
#include <mi32/doublear.h>
#endif

#ifndef	INC_MI32_AUTOREFCOUNT_H
#include <mi32/autorefcount.h>
#endif

namespace SPATMOD {

//! Shared (reference counted) data buffer.
class DATABUFFER : public AUTOREFCOUNT< DOUBLE_ARRAY<UINT8> > {
	};

}	// End namespace SPATMOD

#endif	 // INC_SPATMOD_DATABUFFER_H
